/* Unload an array of units from a vehivle and execute code once the vehicle is done unloading 
 * Parameters:
 *  _this select 0:		vehicle
 *  _this select 1:		Units to dismount
 *  _this select 2:		Position to drop off at
 *  _this select 3:		Position to fly to after drop-off 
 *  _this select 4:		(optional string) Code to run when chopper has reached the insertion wp
 *  _this select 5:		(optional string) Code to run when group is out of chopper
 *  _this select 6:		(optional string) Code to run when chopper has reached end position
 */
//if (!isServer) exitWith {/* Server only code */};


private ["_vehicle", "_units", "_code"];

_vehicle = vehicle (_this select 0);
_units = _this select 1;
_dropWP = _this select 2;
_endWP = _this select 3;
_extGrp = group driver _vehicle;
_pilot = driver _vehicle; 

if (!local _pilot) exitWith {/* Needs to run on pilots machine */};

_pilot disableAI "TARGET";
_pilot disableAI "AUTOTARGET";
//_pilot disableAI "FSM";
_pilot setCombatMode "BLUE"; 
_pilot setBehaviour "SAVE";
_pilot enableAttack false;

_tmpName = format["FHQ_Insert_%1_%2", floor(random 10000), floor(random 10000)];
missionNamespace setVariable [_tmpName, _vehicle];
missionNamespace setVariable [_tmpName + "reached", 0];



_wpReach = "";
_afterGetOut = "";
_endReached = format ["{deleteVehicle _x; } forEach (crew (missionNamespace getVariable ""%1"") + [(missionNamespace getVariable ""%1"")]);", _tmpName];

if ((count _this) > 4) then {
	_wpReach = _this select 4;
    diag_log _wpReach;
};

if ((count _this) > 5) then {
	_afterGetOut = _this select 5;
    diag_log _afterGetOut;
};

if ((count _this) > 6) then {
	_endReached = _this select 6;
    diag_log _endReached;
};

_heliH = "Land_HeliPadEmpty_F" createVehicle _dropWP;

_wp = _extGrp addWaypoint [_dropWP, 0];
_wp setWaypointType "MOVE";
_wp setWaypointStatements ["true", format["(missionNamespace getVariable ""%1"") land ""GET OUT""; %2", _tmpName, _wpReach]];
_wp setWaypointCombatMode "BLUE";
_wp setWaypointBehaviour "SAFE";

_wp = _extGrp addWaypoint [_dropWP, 0];
_wp setWaypointType "TR UNLOAD";
_wp setWaypointStatements ["true", format["(missionNamespace getVariable ""%1"") land ""GET OUT"";", _tmpName]];
_wp setWaypointCombatMode "BLUE";
_wp setWaypointBehaviour "SAFE";
_wp setWaypointCompletionRadius 10;

//if (_vehicle isKindOf "Air") then { 
//	waitUntil {_pilot setCombatMode "BLUE"; _pilot setBehaviour "SAVE"; ((getPosATL _vehicle) select 2) < 2};
//} else {
    waitUntil {_pilot setCombatMode "BLUE"; _pilot setBehaviour "SAVE"; ((getPos _vehicle) distance (_dropWP)) < 10};
//};     

{_x setCaptive false; doGetOut _x; unassignVehicle _x;  [_x] allowGetIn false; } forEach _units;

waitUntil {0 == ({_x in _vehicle} count _units)};

call compile _afterGetOut;

deleteWaypoint [_extGrp, 0];
deleteWaypoint [_extGrp, 0];

deleteVehicle _heliH;

_wp = _extGrp addWaypoint [_endWP, 0];
_wp setWaypointType "MOVE";
_wp setWaypointStatements ["true", format["%1", _endReached]];

_pilot enableAI "TARGET";
_pilot enableAI "AUTOTARGET";
_pilot enableAI "FSM";